# Command Compressor Filter by CubeCoded (http://youtube.com/cubecoded)
# Many parts of code from filter by FrodCube (http://youtube.com/frodcube)

from pymclevel import TAG_List
from pymclevel import TAG_Byte
from pymclevel import TAG_Int
from pymclevel import TAG_Compound
from pymclevel import TAG_Short
from pymclevel import TAG_Double
from pymclevel import TAG_String

displayName = "Command Compressor"

inputs = (
	("X offset", (0, -100, 100)),
	("Y offset", (0, -100, 100)),
	("Z offset", (0, -100, 100))
	)

def perform(level, box, options):
	
	cx = box.maxx + options["X offset"]
	cy = box.miny + options["Y offset"]
	cz = box.maxz + options["Z offset"]
	numCommands = 0
	
	command = "summon MinecartCommandBlock ~ ~1 ~ {Command:tp @e[type=MinecartCommandBlock,dx=0,dz=0,y=255,dy=255] @e[type=WitherSkull,c=1,name=CubeCoded],Riding:{id:MinecartCommandBlock,Riding:{id:MinecartCommandBlock,Command:summon WitherSkull ~ ~ ~ {direction:[],CustomName:CubeCoded},Riding:{id:FallingSand,TileID:157,Time:1,DropItem:0}},Command:summon MinecartCommandBlock ~ 255 ~ {Command:kill @e[type=WitherSkull,name=CubeCoded,c=1],"
	endcommand = "}}}"
	
	for y in xrange(box.miny, box.maxy):
		for z in xrange(box.minz, box.maxz):
			for x in xrange(box.minx, box.maxx):
				for (chunk, slices, point) in level.getChunkSlices(box):
					for t in chunk.TileEntities:
						if t["id"].value == "Control" and str(t["x"]) == str(TAG_Int(x)) and str(t["y"]) == str(TAG_Int(y)) and str(t["z"]) == str(TAG_Int(z)):
							
							command = command + "Riding:{id:MinecartCommandBlock,Command:" + t["Command"].value + ","
							endcommand = endcommand + "}"
							numCommands = numCommands + 1
							chunk.dirty = True
	
	command = command + "Riding:{id:MinecartCommandBlock,Command:kill @e[type=MinecartCommandBlock,dx=0,dz=0,y=1,dy=255]}" + endcommand
	
	if len(command) > 32750:
		raise Exception("Your command is too big to fit in one command block! Try selecting portions of the blocks and separating it into pieces.")
	else:
		CreateCommandBlock(level, cx, cy, cz, command, numCommands)


def CreateCommandBlock(level, ox, oy, oz, command, numCommands):
	level.setBlockAt(ox, oy, oz, 137)
	level.setBlockAt(ox+1, oy, oz, 77)
	level.setBlockDataAt(ox+1, oy, oz, 1)
	level.setBlockAt(ox, oy+1, oz, 68)
	level.setBlockDataAt(ox, oy+1, oz, 5)
	
	control = TAG_Compound()
	control["Command"] = TAG_String(command)
	control["id"] = TAG_String("Control")
	control["x"] = TAG_Int(ox)
	control["y"] = TAG_Int(oy)
	control["z"] = TAG_Int(oz)
	level.addTileEntity(control)
	
	control = TAG_Compound()
	control["Text2"] = TAG_String(str(numCommands) + " Commands")
	control["Text4"] = TAG_String("by CubeCoded")
	control["id"] = TAG_String("Sign")
	control["x"] = TAG_Int(ox)
	control["y"] = TAG_Int(oy+1)
	control["z"] = TAG_Int(oz)
	level.addTileEntity(control)